## brlaser 4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(brlaser CXX)
set(BRLASER_VERSION "4")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to RelWithDebInfo")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type (default RelWithDebInfo)" FORCE)
endif()

include(CMakePushCheckState)
include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)


## Enable assertions for all builds
## (cmake by default sets NDEBUG for release builds)

foreach(var
    CMAKE_CXX_FLAGS_RELEASE
    CMAKE_CXX_FLAGS_RELWITHDEBINFO
    CMAKE_CXX_FLAGS_MINSIZEREL)
  string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " " "${var}" "${${var}}")
endforeach()


## Configure the compiler

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

macro(extra_cxx_compiler_flag FLAG)
  string(REGEX REPLACE "[^A-Za-z_0-9]" "_" SFLAG ${FLAG})
  check_cxx_compiler_flag(${FLAG} COMPILER_SUPPORT_${SFLAG})
  if(COMPILER_SUPPORT_${SFLAG})
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} ${FLAG}")
  endif()
endmacro(extra_cxx_compiler_flag)

# Compiler warnings
extra_cxx_compiler_flag("-Wall")
extra_cxx_compiler_flag("-Wno-missing-braces")
# Some security flags
extra_cxx_compiler_flag("-fstack-protector-strong")
extra_cxx_compiler_flag("-Wformat")
extra_cxx_compiler_flag("-Werror=format-security")
extra_cxx_compiler_flag("-D_FORTIFY_SOURCE=2")
# Enable the supported flags, but give priority to CXXFLAGS env var
set(CMAKE_CXX_FLAGS "${EXTRA_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")


## Configure CUPS

find_program(CUPS_CONFIG NAMES cups-config)
if(NOT CUPS_CONFIG)
  message(FATAL_ERROR "cups-config command not found. Are the CUPS development packages installed?")
endif()

if(NOT CUPS_DATA_DIR)
  execute_process(
    COMMAND "${CUPS_CONFIG}" --datadir
    OUTPUT_VARIABLE CUPS_DATA_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
if(NOT CUPS_SERVER_BIN)
  execute_process(
    COMMAND "${CUPS_CONFIG}" --serverbin
    OUTPUT_VARIABLE CUPS_SERVER_BIN
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
if(NOT CUPS_CFLAGS)
  execute_process(
    COMMAND "${CUPS_CONFIG}" --cflags
    OUTPUT_VARIABLE CUPS_CFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
if(NOT CUPS_LDFLAGS)
  execute_process(
    COMMAND "${CUPS_CONFIG}" --ldflags
    OUTPUT_VARIABLE CUPS_LDFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()
if(NOT CUPS_LIBS)
  execute_process(
    COMMAND "${CUPS_CONFIG}" --image --libs
    OUTPUT_VARIABLE CUPS_LIBS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

cmake_push_check_state()
set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${CUPS_CFLAGS}")
check_include_file_cxx(cups/raster.h HAVE_CUPS_RASTER_H)
cmake_pop_check_state()
if(NOT HAVE_CUPS_RASTER_H)
  message(SEND_ERROR "<cups/raster.h> header not found. Are the CUPS development packages installed?")
endif()


## Build instructions

configure_file(
  "${PROJECT_SOURCE_DIR}/brlaser.drv.in"
  "${PROJECT_BINARY_DIR}/brlaser.drv")

configure_file(
  "${PROJECT_SOURCE_DIR}/config.h.in"
  "${PROJECT_BINARY_DIR}/config.h")

include_directories("${PROJECT_BINARY_DIR}")

add_executable(rastertobrlaser src/main.cc src/job.cc src/line.cc src/debug.cc)
target_compile_options(rastertobrlaser PRIVATE ${CUPS_CFLAGS})
target_link_libraries(rastertobrlaser ${CUPS_LIBS})
target_link_libraries(rastertobrlaser ${CUPS_LDFLAGS})

add_executable(brdecode src/brdecode.cc)
add_executable(test_lest test/test_lest.cc)
add_executable(test_line test/test_line.cc src/line.cc)
add_executable(test_block test/test_block.cc)

enable_testing()
add_test(test_lest test_lest)
add_test(test_line test_line)
add_test(test_block test_block)

# Autotools-style "make check" command
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
add_dependencies(check test_lest test_line test_block)


# Installation

install(
  TARGETS rastertobrlaser
  DESTINATION "${CUPS_SERVER_BIN}/filter")
install(
  FILES "${PROJECT_BINARY_DIR}/brlaser.drv"
  DESTINATION "${CUPS_DATA_DIR}/drv")

## brlaser 3

=== debian/changelog ===
brlaser (3-5~ubuntu1) xenial-proposed; urgency=medium

  * SRU: LP: #1592659, fix build failure.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 15 Jun 2016 08:28:18 +0200

brlaser (3-5) unstable; urgency=medium

  [ Peter Spiess-Knafl ]
  * Add patch to add missing #include <string> (Closes: #822500)

  [ Didier Raboud ]
  * Bump S-V to 3.9.8 without changes needed
  * Add debian/gbp.conf to cope with the new git branches

 -- Didier Raboud <odyx@debian.org>  Mon, 25 Apr 2016 21:28:24 +0200

brlaser (3-4) unstable; urgency=medium

  * Import upstream patch to add support for Brother DCP-7055
  * Bump Standards-Version to 3.9.7 without changes needed

 -- Didier Raboud <odyx@debian.org>  Thu, 25 Feb 2016 19:39:14 +0100

brlaser (3-3) unstable; urgency=medium

  * Drop superfluous pyppd build-dependency
  * Make build commands verbose through autotools' V=1

 -- Didier Raboud <odyx@debian.org>  Wed, 09 Jul 2014 08:46:51 +0200

brlaser (3-2) unstable; urgency=medium

  * Correct package description
  * Override dh_auto_configure with a proper --docdir to put the README.md in
    the correct path

 -- Didier Raboud <odyx@debian.org>  Tue, 08 Jul 2014 23:56:50 +0200

brlaser (3-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #753520)

 -- Didier Raboud <odyx@debian.org>  Tue, 08 Jul 2014 09:32:27 +0200

=== debian/control ===
Source: brlaser
Section: text
Priority: optional
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>
Build-Depends: debhelper (>= 9),
 dh-autoreconf,
 libcups2-dev,
 libcupsimage2-dev,
Vcs-Git: https://alioth.debian.org/anonscm/git/printing/brlaser.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=printing/brlaser.git
Homepage: https://github.com/pdewacht/brlaser
XS-Testsuite: autopkgtest
Standards-Version: 3.9.8

Package: printer-driver-brlaser
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: printer driver for (some) Brother laser printers
 CUPS filter driver supporting (some) Brother laser printer.
 .
 This driver is known to support these printers:
  * Brother DCP-7030
  * Brother DCP-7065DN
 .
 This package contains the CUPS filter driver for the supported laser printers.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --docdir=/usr/share/doc/printer-driver-brlaser

override_dh_auto_build:
	dh_auto_build -- V=1

override_dh_auto_test:
	dh_auto_test -- V=1

## brlaser 4

=== debian/changelog ===
brlaser (4-1) unstable; urgency=medium

  * New upstream release
    - Build system changed to CMake

  * Packaging cleanup: 
    - Bump debhelper compat to 11
    - Update packaging to cmake build system
    - Install README.md as doc
    - Cleanup the superfluous Testsuite control field
    - Refresh d/copyright
    - Enable hardening

 -- Didier Raboud <odyx@debian.org>  Fri, 02 Mar 2018 08:08:59 +0100

brlaser (3-6) unstable; urgency=medium

  * Update debian/control syntax with cme
  * Bump Standards-Version to 4.1.3 without changes needed
  * Update Vcs-* fields for the move to salsa.d.o
  * Initialize git-dpm

 -- Didier Raboud <odyx@debian.org>  Fri, 09 Feb 2018 17:10:46 +0100

=== debian/control ===
Source: brlaser
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>
Section: text
Priority: optional
Build-Depends: debhelper (>= 11),
               cmake,
               libcups2-dev,
               libcupsimage2-dev
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/printing-team/brlaser
Vcs-Git: https://salsa.debian.org/printing-team/brlaser.git
Homepage: https://github.com/pdewacht/brlaser

Package: printer-driver-brlaser
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: printer driver for (some) Brother laser printers
 CUPS filter driver supporting (some) Brother laser printer.
 .
 This driver is known to support these printers:
  * Brother DCP-7030
  * Brother DCP-7065DN
 .
 This package contains the CUPS filter driver for the supported laser printers.

## brlaser 5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.1)
 project(brlaser CXX)
-set(BRLASER_VERSION "4")
+set(BRLASER_VERSION "5")
 
 if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "No build type selected, default to RelWithDebInfo")
@@ -112,7 +112,7 @@
 target_link_libraries(rastertobrlaser ${CUPS_LIBS})
 target_link_libraries(rastertobrlaser ${CUPS_LDFLAGS})
 
-add_executable(brdecode src/brdecode.cc)
+add_executable(brdecode EXCLUDE_FROM_ALL src/brdecode.cc)
 add_executable(test_lest test/test_lest.cc)
 add_executable(test_line test/test_line.cc src/line.cc)
 add_executable(test_block test/test_block.cc)

=== debian/changelog ===
brlaser (5-1) unstable; urgency=medium

  * New upstream release

  * Use secure copyright file specification URI.
  * Bump debhelper from old 11 to 12.
  * Bump S-V to 4.4 without changes needed
  * Refresh package description to list the currently supported printers
  * Tiny fixup in the d/copyright file

 -- Didier Raboud <odyx@debian.org>  Thu, 05 Sep 2019 09:48:23 +0200

## brlaser 6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.1)
 project(brlaser CXX)
-set(BRLASER_VERSION "5")
+set(BRLASER_VERSION "6")
 
 if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "No build type selected, default to RelWithDebInfo")

=== debian/changelog ===
brlaser (6-1) unstable; urgency=medium

  * New upstream release
  * Set upstream metadata fields: Repository.

 -- Didier Raboud <odyx@debian.org>  Mon, 30 Sep 2019 20:35:40 +0200

=== debian/control ===
Source: brlaser
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>
Section: text
Priority: optional
Build-Depends: cmake,
               libcups2-dev,
               libcupsimage2-dev,
               debhelper-compat (= 12)
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/printing-team/brlaser
Vcs-Git: https://salsa.debian.org/printing-team/brlaser.git
Homepage: https://github.com/pdewacht/brlaser

Package: printer-driver-brlaser
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: printer driver for (some) Brother laser printers
 CUPS filter driver supporting (some) Brother laser printer.
 .
 This driver has been reported to work with these printers:
 .
  * Brother DCP-1510
  * Brother DCP-1602
  * Brother DCP-7030
  * Brother DCP-7040
  * Brother DCP-7055
  * Brother DCP-7055W
  * Brother DCP-7060D
  * Brother DCP-7065DN
  * Brother DCP-7080
  * Brother DCP-L2500D
  * Brother DCP-L2540DW
  * Brother HL-1110 series
  * Brother HL-1200 series
  * Brother HL-L2300D series
  * Brother HL-L2320D series
  * Brother HL-L2340D series
  * Brother HL-L2360D series
  * Brother MFC-1910W
  * Brother MFC-7240
  * Brother MFC-7360N
  * Brother MFC-7365DN
  * Brother MFC-7840W
  * Brother MFC-L2710DW
  * Lenovo M7605D
 This package contains the CUPS filter driver for the supported laser printers.

=== debian/tests/control ===
Tests: printer-driver-brlaser
Restrictions: needs-root
Depends: printer-driver-brlaser, cups, cups-client (>= 1.7.3-5~)

=== debian/watch ===
version=2
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/brlaser-$1\.tar\.gz/ \
  https://github.com/pdewacht/brlaser/tags .*/v?(\d\S*)\.tar\.gz

## brlaser 6.2.6

=== debian/changelog ===
brlaser (6.2.6-1) unstable; urgency=medium

  * Update to new upstream version 6.2.6 using debrebase.
    (only patch was applied upstream and automatically removed9
    (Closes: #1051303)

  [ QwertyChouskie ]
  * Update upstream repository URLs to new upstream
    (in debian/control, debian/copyright, debian/upstream/metadata,
     debian/watch)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 07 Jan 2025 23:46:56 +0100

brlaser (6-3) unstable; urgency=medium

  * debian/control: add myself to Uploaders:
  * debian/control: add Rules-Requires-Root:
  * fix printing of documents with images (Closes: #999584, #1004133)
    cherry picked from upstream 9d7ddda8383bfc4d205b5e1b49de2b8bcd9137f1

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 02 Apr 2022 17:03:02 +0200

brlaser (6-2) unstable; urgency=medium

  * Remove myself from Uploaders
  * Run wrap-and-sort -baskt
  * Update watch file format version to 4
  * Bump debhelper from old 12 to 13
  * Set upstream metadata fields
  * Remove listed license files (COPYING) from copyright
  * Add Salsa CI configuration
  * S-V: Update to 4.6.0 without changes needed

 -- Didier Raboud <odyx@debian.org>  Wed, 01 Sep 2021 16:37:48 +0200

## brlaser 6.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.1)
-project(brlaser CXX)
-set(BRLASER_VERSION "6")
+project(Owl-Maintain/brlaser CXX)
+set(BRLASER_VERSION "6.2.7")
 
 if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "No build type selected, default to RelWithDebInfo")
@@ -39,10 +39,11 @@
 # Compiler warnings
 extra_cxx_compiler_flag("-Wall")
 extra_cxx_compiler_flag("-Wno-missing-braces")
-# Some security flags
+extra_cxx_compiler_flag("-Wdate-time")
+# Some hardening flags
 extra_cxx_compiler_flag("-fstack-protector-strong")
 extra_cxx_compiler_flag("-Wformat")
-extra_cxx_compiler_flag("-Werror=format-security")
+extra_cxx_compiler_flag("-Wformat -Werror=format-security")
 extra_cxx_compiler_flag("-D_FORTIFY_SOURCE=2")
 # Enable the supported flags, but give priority to CXXFLAGS env var
 set(CMAKE_CXX_FLAGS "${EXTRA_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
@@ -116,15 +117,17 @@
 add_executable(test_lest test/test_lest.cc)
 add_executable(test_line test/test_line.cc src/line.cc)
 add_executable(test_block test/test_block.cc)
+add_executable(test_job test/test_job.cc src/job.cc src/line.cc)
 
 enable_testing()
 add_test(test_lest test_lest)
 add_test(test_line test_line)
 add_test(test_block test_block)
+add_test(test_job test_job)
 
 # Autotools-style "make check" command
 add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
-add_dependencies(check test_lest test_line test_block)
+add_dependencies(check test_lest test_line test_block test_job)
 
 
 # Installation

=== debian/changelog ===
brlaser (6.2.7-2) unstable; urgency=medium

  * add cmake4.patch (Closes: #1112735)
  * debian/control: bump standard to 4.7.2 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 17 Oct 2025 20:04:30 +0200

brlaser (6.2.7-1) unstable; urgency=medium

  * Update to new upstream version 6.2.7.
    fix for duplex long-edge actually prints duplex short-edge
    (Closes: #1101579)

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 18 Apr 2025 20:04:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,24 @@
 Source: brlaser
 Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
-Uploaders: Didier Raboud <odyx@debian.org>
+Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Section: text
 Priority: optional
-Build-Depends: cmake,
-               libcups2-dev,
-               libcupsimage2-dev,
-               debhelper-compat (= 12)
-Standards-Version: 4.4.0
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ libcups2-dev,
+ libcupsimage2-dev,
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/printing-team/brlaser
 Vcs-Git: https://salsa.debian.org/printing-team/brlaser.git
-Homepage: https://github.com/pdewacht/brlaser
+Homepage: https://github.com/Owl-Maintain/brlaser
+Rules-Requires-Root: no
 
 Package: printer-driver-brlaser
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: printer driver for (some) Brother laser printers
  CUPS filter driver supporting (some) Brother laser printer.
  .

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/brlaser-$1\.tar\.gz/ https://github.com/Owl-Maintain/brlaser/tags .*/v?(\d\S*)\.tar\.gz

## brlaser 6.2.8

=== debian/changelog ===
brlaser (6.2.8-1) unstable; urgency=medium

  * New upstream release.

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 13 Feb 2026 19:27:45 +0100

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/brlaser-$1\.tar\.gz/ https://github.com/Owl-Maintain/brlaser/tags .*/v?(\d\S*)\.tar\.gz debian uupdate
